-- /packages/intranet-trans-project-feedback/sql/postgres/intranet-trans-project-feedback-create.sql
--
-- Copyright (C) 2011-2015 ]project-open[ 
--
-- This program is free software. You can redistribute it
-- and/or modify it under the terms of the GNU General
-- Public License as published by the Free Software Foundation;
-- either version 2 of the License, or (at your option)
-- any later version. This program is distributed in the
-- hope that it will be useful, but WITHOUT ANY WARRANTY;
-- without even the implied warranty of MERCHANTABILITY or
-- FITNESS FOR A PARTICULAR PURPOSE.
-- See the GNU General Public License for more details.
--
-- @author klaus.hofeditz@project-open.com


-- --------------------------------------------------------------------------------------------------------------------------
-- Create Survey & Questions  
-- --------------------------------------------------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION inline_0 ()
RETURNS INTEGER AS $BODY$

declare
        v_count                 integer;
        v_package_id            integer;
        v_survey_id             integer;
begin

        select count(*) into v_count from survsimp_surveys where name = 'Project Translation Feedback';

        IF 0 = v_count THEN
	        -- Get package id of package intranet-employee-evaluation
                select package_id into v_package_id from apm_packages where package_key = 'simple-survey';

                select survsimp_survey__new (
                       null,
                       'Project Translation Feedback',
                       'Project Translation Feedback',
                       '',
                       'f',		     -- description_html_p 
                       't',		     -- single_response_p
                       't',		     -- single_editable_p
                       't',		     -- enabled_p
                       'general',            -- type
                       'list',               -- display_type,
                       624,
                       v_package_id
              ) into v_survey_id;
        END IF;
        return 0;
end;$BODY$ LANGUAGE 'plpgsql';
SELECT inline_0 ();
DROP FUNCTION inline_0 ();

-- Create Questions 
CREATE OR REPLACE FUNCTION inline_1 ()
RETURNS INTEGER AS $BODY$

declare
        v_count                 integer;
        v_survey_id             integer;
	v_next_choice_id	integer;
	v_question_id		integer;
begin

      select count(*) into v_count
      from survsimp_question_choices 
      where 
      	    label = 'CC - Client Complaint' 
      	    OR label = 'NC - Issue but no client complaint'
	    OR label = 'YAY - No issue'; 
	   
      IF 3 = v_count THEN 
      	 return 0; 
      END IF; 

      select survey_id into v_survey_id from survsimp_surveys where name = 'Project Translation Feedback';
      select acs_object__new (null, 'survsimp_question') into v_question_id;

      insert into survsimp_questions(question_id, survey_id, sort_key, question_text, abstract_data_type, required_p, active_p, presentation_type, presentation_options, presentation_alignment)
        values (
               v_question_id,
               v_survey_id,
               100,                                                                                      --new__sort_key
               'Type',											 --new__question_text
               'choice',                                                                          	 --new__abstract_data_type (e.g. choice, text)
               'f',                                                                                      --new__required_p
               't',                                                                                      --new__active_p
               'select',                                                                                 --new__presentation_type
               '',                                                                                       --new__presentation_options
               'below'                                                                                   --new__presentation_alignment
        );

        select survsimp_choice_id_sequence.nextval into v_next_choice_id from dual;
        insert into survsimp_question_choices (choice_id, question_id, label, sort_order) values (v_next_choice_id, v_question_id, 'CC - Client Complaint' ,1);

        select survsimp_choice_id_sequence.nextval into v_next_choice_id from dual;
        insert into survsimp_question_choices (choice_id, question_id, label, sort_order) values (v_next_choice_id, v_question_id, 'NC - Issue but no client complaint' ,2);

        select survsimp_choice_id_sequence.nextval into v_next_choice_id from dual;
        insert into survsimp_question_choices (choice_id, question_id, label, sort_order) values (v_next_choice_id, v_question_id, 'YAY - No issue' ,3);
	
	return 0; 

end;$BODY$ LANGUAGE 'plpgsql';
SELECT inline_1 ();
DROP FUNCTION inline_1 ();


CREATE OR REPLACE FUNCTION inline_0 ()
RETURNS INTEGER AS $BODY$

declare
        v_count                 integer;
        v_survey_id             integer;
        v_next_choice_id        integer;
        v_question_id           integer;
begin

      select count(*) into v_count
      from survsimp_question_choices
      where
            label = 'TC - Issue with translator delivery resulting in late client delivery'
            OR label = 'LIH - Late Inhouse. Late delivery due to inhouse issues'
            OR label = 'IHP - Inhouse proofreading issues (typos, numbers, etc.)'
	    OR label = 'TTI - Translator Terminology inaccurate, text does not read well in target Language';

      IF 4 = v_count THEN 
      	 return 0;
      END IF;

      select survey_id into v_survey_id from survsimp_surveys where name = 'Project Translation Feedback';
      select acs_object__new (null, 'survsimp_question') into v_question_id;

      insert into survsimp_questions(question_id, survey_id, sort_key, question_text, abstract_data_type, required_p, active_p, presentation_type, presentation_options, presentation_alignment)
        values (
               v_question_id,
               v_survey_id,
               200,                                                                                      --new__sort_key,
               'Sub Type',                                                                                 --new__question_text,
               'choice',                                                                                 --new__abstract_data_type (e.g. choice, text)
               'f',                                                                                      --new__required_p,
               't',                                                                                      --new__active_p,
               'select',                                                                                   --new__presentation_type,
               '',                                                                                       --new__presentation_options,
               'below'                                                                                   --new__presentation_alignment
        );

        select survsimp_choice_id_sequence.nextval into v_next_choice_id from dual;
        insert into survsimp_question_choices (choice_id, question_id, label, sort_order) values (v_next_choice_id, v_question_id, 'TC - Issue with translator delivery resulting in late client delivery' ,1);

        select survsimp_choice_id_sequence.nextval into v_next_choice_id from dual;
        insert into survsimp_question_choices (choice_id, question_id, label, sort_order) values (v_next_choice_id, v_question_id, 'LIH - Late Inhouse. Late delivery due to inhouse issues' ,2);

        select survsimp_choice_id_sequence.nextval into v_next_choice_id from dual;
        insert into survsimp_question_choices (choice_id, question_id, label, sort_order) values (v_next_choice_id, v_question_id, 'IHP - Inhouse proofreading issues (typos, numbers, etc.)' ,3);

        select survsimp_choice_id_sequence.nextval into v_next_choice_id from dual;
        insert into survsimp_question_choices (choice_id, question_id, label, sort_order) values (v_next_choice_id, v_question_id, 'TTI - Translator Terminology inaccurate, text does not read well in target Language' ,4);

	return 0; 

end;$BODY$ LANGUAGE 'plpgsql';
SELECT inline_0 ();
DROP FUNCTION inline_0 ();



CREATE OR REPLACE FUNCTION inline_0 ()
RETURNS INTEGER AS $BODY$

declare
        v_count                 integer;
        v_survey_id             integer;
        v_question_id           integer;
begin

      select count(*) into v_count
      from survsimp_questions
      where
            question_text = 'Corrective Action';

      IF 1 = v_count THEN 
      	 return 0;
      END IF;

      select survey_id into v_survey_id from survsimp_surveys where name = 'Project Translation Feedback';
      select acs_object__new (null, 'survsimp_question') into v_question_id;

      insert into survsimp_questions(question_id, survey_id, sort_key, question_text, abstract_data_type, required_p, active_p, presentation_type, presentation_options, presentation_alignment)
        values (
               v_question_id,
               v_survey_id,
               300,                                                                                      --new__sort_key,
               'Corrective Action',                                                                       --new__question_text,
               'text',											 --new__abstract_data_type (e.g. choice, text)
               'f',                                                                                      --new__required_p,
               't',                                                                                      --new__active_p,
               'textarea',                                                                                 --new__presentation_type,
               '',                                                                                       --new__presentation_options,
               'below'                                                                                   --new__presentation_alignment
        );
	return 0; 

end;$BODY$ LANGUAGE 'plpgsql';
SELECT inline_0 ();
DROP FUNCTION inline_0 ();


CREATE OR REPLACE FUNCTION inline_0 ()
RETURNS INTEGER AS $BODY$

declare
        v_count                 integer;
        v_survey_id             integer;
        v_question_id           integer;
begin

      select count(*) into v_count
      from 
      	   survsimp_questions
      where
            question_text = 'Preventive Action';

      IF 1 = v_count THEN 
      	 return 0; 
      END IF;

      select survey_id into v_survey_id from survsimp_surveys where name = 'Project Translation Feedback';
      select acs_object__new (null, 'survsimp_question') into v_question_id;

      insert into survsimp_questions(question_id, survey_id, sort_key, question_text, abstract_data_type, required_p, active_p, presentation_type, presentation_options, presentation_alignment)
        values (
               v_question_id,
               v_survey_id,
               400,                                                                                      --new__sort_key,
               'Preventive Action',                                                                       --new__question_text,
               'text',                                                                                   --new__abstract_data_type (e.g. choice, text)
               'f',                                                                                      --new__required_p,
               't',                                                                                      --new__active_p,
               'textarea',                                                                                 --new__presentation_type,
               '',                                                                                       --new__presentation_options,
               'below'                                                                                   --new__presentation_alignment
        );

	return 0; 

end;$BODY$ LANGUAGE 'plpgsql';
SELECT inline_0 ();
DROP FUNCTION inline_0 ();


-- END SURVEY ---------------------------------------------------------------------------------------------------------------


-- -------------------------------------------------------------------------------------------------------------------------- 
-- Portlet Components 
-- -------------------------------------------------------------------------------------------------------------------------- 

-- Feedback on Project Page 
CREATE OR REPLACE FUNCTION inline_0 ()
RETURNS INTEGER AS $BODY$

declare
        v_plugin_id           integer;
	v_employees           integer;
begin

	-- Groups 
	select group_id into v_employees from groups where group_name = 'Employees';

	-- Plugins 
	SELECT im_component_plugin__new (
        	null,                                   -- plugin_id
	        'im_component_plugin',                  -- object_type
        	now(),                                  -- creation_date
        	null,                                   -- creation_user
        	null,                                   -- creation_ip
        	null,                                   -- context_id
        	'Project Translation Feedback',            -- plugin_name
        	'intranet-trans-project-feedback',   -- package_name
        	'left',                                    -- location
        	'/intranet/projects/view',                 -- page_url
        	null,                                      -- view_name
        	200,                                       -- sort_order
        	'im_project_translation_feedback_questions_component $project_id',
        	'lang::message::lookup "" intranet-trans-project-feedback.ProjectTranslationFeedback "Project Translation Feedback"'
	into v_plugin_id);

	PERFORM im_grant_permission(v_plugin_id,  v_employees, 'read');

        return 0;

end;$BODY$ LANGUAGE 'plpgsql';
SELECT inline_0 ();
DROP FUNCTION inline_0 ();


-- GRAPHS: Non-Conformity
CREATE OR REPLACE FUNCTION inline_0 ()
RETURNS INTEGER AS $BODY$

declare
        v_plugin_id           integer;
        v_employees           integer;
begin

        -- Groups
        select group_id into v_employees from groups where group_name = 'Employees';

        -- Plugins
        SELECT im_component_plugin__new (
                null,                                   -- plugin_id
                'im_component_plugin',                  -- object_type
                now(),                                  -- creation_date
                null,                                   -- creation_user
                null,                                   -- creation_ip
                null,                                   -- context_id
                'Non-Conformity',  			   -- plugin_name
                'intranet-trans-project-feedback',   -- package_name
                'bottom',								-- location
                '/intranet-trans-project-feedback/dashboard',                 -- page_url
                null,                                      			    -- view_name
                200,                                       			    -- sort_order
                'im_project_translation_graph_panel "Non Conformity" $start_date $end_date $period',
                'lang::message::lookup "" intranet-trans-project-feedback.NonConformity "Non-Conformity"'
        into v_plugin_id);

        PERFORM im_grant_permission(v_plugin_id,  v_employees, 'read');

        return 0;

end;$BODY$ LANGUAGE 'plpgsql';
SELECT inline_0 ();
DROP FUNCTION inline_0 ();


-- Non-Conformity - Proportions
CREATE OR REPLACE FUNCTION inline_0 ()
RETURNS INTEGER AS $BODY$

declare
        v_plugin_id           integer;
        v_employees           integer;
begin

        -- Groups
        select group_id into v_employees from groups where group_name = 'Employees';

        -- Plugins
        SELECT im_component_plugin__new (
                null,                                   -- plugin_id
                'im_component_plugin',                  -- object_type
                now(),                                  -- creation_date
                null,                                   -- creation_user
                null,                                   -- creation_ip
                null,                                   -- context_id
                'Non-Conformity - Proportions',  	-- plugin_name
                'intranet-trans-project-feedback',   -- package_name
                'bottom',                                    -- location
                '/intranet-trans-project-feedback/dashboard',                 -- page_url
                null,                                      -- view_name
                200,                                       -- sort_order
                'im_project_translation_graph_panel "Non Conformity - Proportions" $start_date $end_date $period',
                'lang::message::lookup "" intranet-trans-project-feedback.NonConformityProportions "Non-Conformity - Proportions"'
        into v_plugin_id);

        PERFORM im_grant_permission(v_plugin_id,  v_employees, 'read');

        return 0;

end;$BODY$ LANGUAGE 'plpgsql';
SELECT inline_0 ();
DROP FUNCTION inline_0 ();



-- Non-Conformity - Percentage
CREATE OR REPLACE FUNCTION inline_0 ()
RETURNS INTEGER AS $BODY$

declare
        v_plugin_id           integer;
        v_employees           integer;
begin

        -- Groups
        select group_id into v_employees from groups where group_name = 'Employees';

        -- Plugins
        SELECT im_component_plugin__new (
                null,                                   -- plugin_id
                'im_component_plugin',                  -- object_type
                now(),                                  -- creation_date
                null,                                   -- creation_user
                null,                                   -- creation_ip
                null,                                   -- context_id
                'Non-Conformity - Percentage',  -- plugin_name
                'intranet-trans-project-feedback',   -- package_name
                'bottom',                                    -- location
                '/intranet-trans-project-feedback/dashboard',                 -- page_url
                null,                                      -- view_name
                200,                                       -- sort_order
                'im_project_translation_graph_panel "Non Conformity - Percentage" $start_date $end_date $period',
                'lang::message::lookup "" intranet-trans-project-feedback.NonConformityPercentage "Non-Conformity - Percentage"'
        into v_plugin_id);

        PERFORM im_grant_permission(v_plugin_id,  v_employees, 'read');

        return 0;

end;$BODY$ LANGUAGE 'plpgsql';
SELECT inline_0 ();
DROP FUNCTION inline_0 ();


-- Non-Conformity - Type
CREATE OR REPLACE FUNCTION inline_0 ()
RETURNS INTEGER AS $BODY$

declare
        v_plugin_id           integer;
        v_employees           integer;
begin

        -- Groups
        select group_id into v_employees from groups where group_name = 'Employees';

        -- Plugins
        SELECT im_component_plugin__new (
                null,                                   -- plugin_id
                'im_component_plugin',                  -- object_type
                now(),                                  -- creation_date
                null,                                   -- creation_user
                null,                                   -- creation_ip
                null,                                   -- context_id
                'Conformity vs. Non-Conformity',  -- plugin_name
                'intranet-trans-project-feedback',   -- package_name
                'bottom',                                    -- location
                '/intranet-trans-project-feedback/dashboard',                 -- page_url
                null,                                      -- view_name
                200,                                       -- sort_order
                'im_project_translation_graph_panel "Conformity vs Non-Conformity" $start_date $end_date $period',
                'lang::message::lookup "" intranet-trans-project-feedback.ConformityVSNonConformity "Conformity vs Non-Conformity"'
        into v_plugin_id);

        PERFORM im_grant_permission(v_plugin_id,  v_employees, 'read');

        return 0;

end;$BODY$ LANGUAGE 'plpgsql';
SELECT inline_0 ();
DROP FUNCTION inline_0 ();

-- -----------------------------------------------------------------------------------------------------------------------
-- REST Data-Source for the report
-- -----------------------------------------------------------------------------------------------------------------------

-- Non-Conformity Main Report
create or replace function inline_0 ()
returns integer as $body$
DECLARE
        v_id                    integer;
        v_count                 integer;
	v_report_id		integer;
	foo			integer;
BEGIN
        SELECT  count(*) INTO v_count
        FROM    im_reports where report_code = 'translation_project_feedback_non_conformity';
        IF v_count > 0 THEN return 1; END IF;

	SELECT im_report_new (
        	'REST Non-Conformity',						  -- report_name
        	'translation_project_feedback_non_conformity',  	  	  -- report_code
        	'intranet-trans-project-feedback',                	  -- package_key
        	1000,                                                             -- report_sort_order
        	(select menu_id from im_menus where label = 'reporting-rest'),    -- parent_menu_id
        	''
	) into v_report_id;

	update im_reports set report_description = 'Shows Total number of projects sampled vs. Projects with issues' where report_code = 'translation_project_feedback_non_conformity';

	update 
	    im_reports
	set 
	    report_sql = '
                select 
                    t._%period% as first_day_period,
                    sum(t.number_projects) as number_projects,
                    sum(t.number_projects_non_conform) as number_projects_non_conform,
	            CASE sum(t.number_projects) = 0
        	    	WHEN true THEN
            			0
            		ELSE
            			round((100 * sum(t.number_projects_non_conform)/sum(t.number_projects))) 
	            END as percentage_non_conform
                from (
                            select 
				s.project_start_date as _day,
                                to_char(s.project_start_date, ''YYYY-MM'') as _month,
                                to_char(s.project_start_date, ''YYYY-Q'') as _quarter,
			        to_char(s.project_start_date, ''YYYY'') as _year,
                                s.number_projects,
                                s.number_projects_non_conform
                            from (
                                select
                                    im_day_enumerator as project_start_date,
                                    (select 
                            		count(*) 
                             	     from 
                            		im_projects 
                             	     where 
                            		start_date::date = im_day_enumerator::date
                            		and parent_id is null
					and project_id in (
					    select distinct sr.related_object_id 
					    from survsimp_responses sr, survsimp_surveys ss 
					    where ss.name = ''Project Translation Feedback'' and ss.survey_id = sr.survey_id
					)
                             	    ) as number_projects,
                                    (select count(*) from (
                                         select distinct on (related_object_id)
                                            r.related_object_id
                                         from
                                            im_projects p,
                        		    (select distinct on (related_object_id) * from survsimp_responses order by related_object_id, response_id DESC) r,
                                            survsimp_question_responses qr,
                                            survsimp_surveys s,
                                            survsimp_questions q
                                         where
                                            s.name = ''Project Translation Feedback''
                                            and r.survey_id = s.survey_id
                                            and r.related_object_id = p.project_id
                                            and r.response_id = qr.response_id
                                            and q.survey_id = s.survey_id
                                            and (q.question_text = ''Sub Type'' or q.question_text = ''Type'')
                                            and q.question_id = qr.question_id
                                            and qr.choice_id in (select choice_id from survsimp_question_choices where label <> ''YAY - No issue'')
                                            and p.start_date::date = im_day_enumerator::date
					    and p.project_id in (
					    	select distinct sr.related_object_id 
					    	from survsimp_responses sr, survsimp_surveys ss 
					    	where ss.name = ''Project Translation Feedback'' and ss.survey_id = sr.survey_id
					    )
                                          group by
                                        r.related_object_id
                                    ) p) as number_projects_non_conform
                                from
                                    im_day_enumerator(''%start_date%''::date, ''%end_date%''::date)
                            ) s
                    ) t
                group by 
                    t._%period%
		order by 
		    t._%period%;
	    '
	where 
	      report_code = 'translation_project_feedback_non_conformity';
		
	SELECT acs_permission__grant_permission( (select menu_id from im_menus where label = 'translation_project_feedback_non_conformity'), (select group_id from groups where group_name = 'Employees'), 'read') into foo;
        return 0;

end;$body$ language 'plpgsql';
SELECT inline_0 ();
drop function inline_0 ();


-- Non-Conformity - Proportions
create or replace function inline_0 ()
returns integer as $body$
DECLARE
        v_id                    integer;
        v_count                 integer;
	v_report_id		integer;
	foo			integer;
BEGIN
        SELECT  count(*) INTO v_count
        FROM    im_reports where report_code = 'translation_project_feedback_non_conformity_proportions';
        IF v_count > 0 THEN 
	   RAISE NOTICE 'Report w/ code: translation_project_feedback_non_conformity_proportions already exists, skipped creation';
	   return 1; 
        END IF;

	SELECT im_report_new (
        	'REST Non-Conformity (Proportions)',                              -- report_name
        	'translation_project_feedback_non_conformity_proportions',  	  -- report_code
        	'intranet-trans-project-feedback',                	  	  -- package_key
        	1000,                                                             -- report_sort_order
        	(select menu_id from im_menus where label = 'reporting-rest'),    -- parent_menu_id
        	''
	) into v_report_id;

	update im_reports set report_description = 'Shows Total number of projects sampled vs. Projects with issues' where report_code = 'translation_project_feedback_non_conformity_proportions';

	update 
	    im_reports
	set 
	    report_sql = '
            select 
	    	CASE qr.choice_id is null
                WHEN true THEN
                        ''None'' 
                ELSE
                        (select label from survsimp_question_choices where choice_id = qr.choice_id)
		END as category,
                count(*)
            from 
                        (
                        SELECT DISTINCT ON (related_object_id) 
                            *
                        FROM   survsimp_responses
                        ORDER  BY related_object_id, response_id DESC
                        ) r, 
                        im_projects p,
                        survsimp_question_responses qr,
                        survsimp_surveys s,
                        survsimp_questions q
            where
                        s.name = ''Project Translation Feedback''
                        and r.survey_id = s.survey_id
                        and r.related_object_id = p.project_id
                        and r.response_id = qr.response_id
                        and q.survey_id = s.survey_id
                        and q.question_text = ''Sub Type''
                        and q.question_id = qr.question_id
                        and p.start_date::date between ''%start_date%''::date and ''%end_date%''::date
                	and p.parent_id is null
			and project_id in (
			    select distinct sr.related_object_id 
			    from survsimp_responses sr, survsimp_surveys ss 
			    where ss.name = ''Project Translation Feedback'' and ss.survey_id = sr.survey_id
			)
            group by 
			choice_id;
	    	       
	    '
	where 
	      report_code = 'translation_project_feedback_non_conformity_proportions';
		
	SELECT acs_permission__grant_permission( (select menu_id from im_menus where label = 'translation_project_feedback_non_conformity_proportions'), (select group_id from groups where group_name = 'Employees'), 'read') into foo;
        return 0;

end;$body$ language 'plpgsql';
SELECT inline_0 ();
drop function inline_0 ();
