-- /packages/intranet-trans-project-feedback/sql/postgres/intranet-trans-project-feedback-create.sql
--
-- Copyright (C) 2011-2015 ]project-open[ 
--
-- This program is free software. You can redistribute it
-- and/or modify it under the terms of the GNU General
-- Public License as published by the Free Software Foundation;
-- either version 2 of the License, or (at your option)
-- any later version. This program is distributed in the
-- hope that it will be useful, but WITHOUT ANY WARRANTY;
-- without even the implied warranty of MERCHANTABILITY or
-- FITNESS FOR A PARTICULAR PURPOSE.
-- See the GNU General Public License for more details.
--
-- @author klaus.hofeditz@project-open.com


CREATE OR REPLACE FUNCTION inline_0 ()
RETURNS INTEGER AS $BODY$

declare
        v_count                 integer;
        v_package_id            integer;
        v_survey_id             integer;
	r			record;
	foo			integer;
begin

    select survey_id into v_survey_id from survsimp_surveys where name = 'Project Translation Feedback';

    FOR r IN select question_id from survsimp_questions where survey_id = v_survey_id
        LOOP
		-- rm response questions  
		delete from survsimp_question_responses where question_id = r.question_id; 

		-- rm questions 
		PERFORM survsimp_question__delete(r.question_id);
       END LOOP;

    -- rm response item 
    delete from survsimp_responses where survey_id = v_survey_id;

    -- rm survey 
    delete from acs_object_context_index where ancestor_id = v_survey_id;
    delete from acs_object_context_index where object_id = v_survey_id;
    delete from acs_objects where context_id = v_survey_id;
    PERFORM survsimp_survey__delete(v_survey_id);  

    return 0;

exception when others then 
    raise notice 'Unable to remove package:';
    raise notice '% %', SQLERRM, SQLSTATE;
    return 1;
end;$BODY$ LANGUAGE 'plpgsql';
SELECT inline_0 ();
DROP FUNCTION inline_0 ();


-- Delete REST reports 
delete from im_reports where report_code = 'translation-project-feedback-non-conformity';
delete from im_reports where report_code = 'translation_project_feedback_non_conformity_proportions';


-- delete component 

CREATE OR REPLACE FUNCTION inline_0 ()
RETURNS INTEGER AS $BODY$

declare
        v_plugin_id             integer;
	v_employees		integer;
	foo			integer;
begin

	select group_id into v_employees from groups where group_name = 'Employees';

	select plugin_id into v_plugin_id from im_component_plugins where plugin_name = 'Project Translation Feedback' limit 1; 
	select im_revoke_permission(v_plugin_id, v_employees, 'read') into foo;
	select im_component_plugin__delete(v_plugin_id) into foo;

	select plugin_id into v_plugin_id from im_component_plugins where plugin_name = 'Non-Conformity' limit 1; 
	select im_revoke_permission(v_plugin_id, v_employees, 'read') into foo;
	select im_component_plugin__delete(v_plugin_id) into foo;

	select plugin_id into v_plugin_id from im_component_plugins where plugin_name = 'Non-Conformity - Proportions' limit 1; 
	select im_revoke_permission(v_plugin_id, v_employees, 'read') into foo;
	select im_component_plugin__delete(v_plugin_id) into foo;

	select plugin_id into v_plugin_id from im_component_plugins where plugin_name = 'Non-Conformity - Percentage'  limit 1; 
	select im_revoke_permission(v_plugin_id, v_employees, 'read') into foo;
	select im_component_plugin__delete(v_plugin_id) into foo;

	select plugin_id into v_plugin_id from im_component_plugins where plugin_name = 'Conformity vs. Non-Conformity' limit 1; 
	select im_revoke_permission(v_plugin_id, v_employees, 'read') into foo;
	select im_component_plugin__delete(v_plugin_id) into foo;

	return 0; 

end;$BODY$ LANGUAGE 'plpgsql';
SELECT inline_0 ();
DROP FUNCTION inline_0 ();
